program list_sample;

{$mode objfpc}{$H+}

uses
  Classes, SysUtils,
  exstrings, exList, exListFace;

type
  TMyIntegers = specialize TGenericList<integer>; // thst's how
    //specialize a generic on integer

function CompareIntegers(const aInt1, aInt2: integer): integer;
begin result:=aInt1 - aInt2; end;

type

  { TMyRecord }

  TMyRecord = object //no matter it called "MyRecord"
    a, b: integer;
    function Compare(const ax1, ax2: TMyRecord): integer;
    procedure Destroy;
  end;


function CreateMyRecord: TMyRecord;
begin
  result.a:=random(10);
  result.b:=random(10);
end;

function TMyRecord.Compare(const ax1, ax2: TMyRecord): integer;
begin
  result:=ax1.a - ax2.a;
end;

function MyRecordToText(const ax: TMyRecord): string;
begin
  //result:='(' + IntToStr(ax.a) + ' ' + IntToStr(ax.b) + ')';
  result:=AsString( ['(', ax.a, ' ', ax.b, ')'] );
end;

procedure TMyRecord.Destroy;
begin
  //Write(a, ', ', b, ': ');
  a:=0;
  b:=0;
  //WriteLN('I am destroyed!');
end;

function DestroyMyRecord(var ax: TMyRecord): boolean;
begin
  ax.Destroy;
  result:=true;
end;

type
  TMyRecords = specialize TGenericList<TMyRecord>;

var
  ints, ints2: TMyIntegers;
  records: TMyRecords;
  i: integer;

begin

  WriteLN;
  WriteLN(' * integers testing * '); //note for user
  ints:=TMyIntegers.Create; //create them!
  ints.Add(6); //first item
  randomize; //randomization
  for i:=1 to 20 do ints.Add(random(100)); //+10 random items
  ints.Add([1, 2, 3]); // +3 items
  ints[1]:=1; //change item #1
  ints.last:=4; //change last item
  ints.Delete([5, 3, 10]);
  ints.Insert(3, 5); //itsert "5" at pos 3
  ints2:=TMyIntegers.Create(ints.DirectItems);

  for i:=0 to ints.count - 1 do Write(ints[i], ' '); // echo
  WriteLN;

  ints.SortingFunction:=@CompareIntegers; //set comparing function
  WriteLN('Sorting...: ', ints.Sort); //sort

  for i:=0 to ints.count - 1 do Write(ints[i], ' '); //echo
  WriteLN;
  {
  for i:=0 to ints.count - 1 do Write(ints2[i], ' '); //echo
  WriteLN;
  }

  ints.Free;
  //WriteLN('CPC: ', ints.Capacity, '; CNT: ', ints.Count);

  WriteLN;
  WriteLN(' * record testing * ');
  //records:=TMyRecords.Create; //creation
  records:=TMyRecords.Create(nil, @CreateMyRecord, nil, @DestroyMyRecord);
  records.NewFunction:=@CreateMyRecord; //an alth. method for initialization
  records.AddNew(9); //add 6 new items
  records.SortingMethod:=@records[0].Compare; //set compare method

  for i:=0 to records.Count - 1 do
    Write('(', records[i].a, ' ', records[i].b, ')  ');
  WriteLN; //echo again

  records.Delete([1, 2]);
  WriteLN('Uncapaced: ', records.UnCapacity);
  records.Sort;

  records.TextFunction:=@MyRecordToText;
  WriteLN(records.AsText);
  records.Free;
end.
















